/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System;using System.Collections.Generic;using MVR.FileManagementSecure;using Random = UnityEngine.Random;namespace PluginIdea.SimpleSlide{    public class SimpleSlide : MVRScript    {        private const string planeObjectName = "renderObject";        private TextureSettings slideTextureSetting = new TextureSettings() { compress = true, linearColor = false };        private List<string> playModes = new List<string> { "Random", "Sequence", "Sequence Inverse" };        private List<int> randomPool = new List<int>();        private List<string> imageList = new List<string>();        private JSONStorableStringChooser playModeChooser;        private JSONStorableBool isAutoPlay;        private JSONStorableFloat switchingInterval;        private JSONStorableUrl folderPath;        private JSONStorableFloat translateDuration;        public JSONStorableAction nextImgAction;        public JSONStorableAction prevImgAction;        private string currentFolderUrl;        private Renderer targetRenderer;        private VideoPlayerModule videoPlayerModule;        private Renderer RenderObj        {            get {                if (targetRenderer == null)                {                    GameObject obj = Utils.GetCustomUnityAsset(containingAtom, "root");                    targetRenderer = obj.transform.Find(planeObjectName).GetComponentInChildren<Renderer>();                }                return targetRenderer;            }        }        public override void Init()        {            base.Init();            Utils.OnInitUI(CreateUIElement);            Utils.SetupInfoTextNoScroll(this, "<size=30><b>SimpleSlide</b></size>", 35, false);            playModeChooser = Utils.SetupStringChooser(this, "Playback Order", playModes, 1, false);            isAutoPlay = Utils.SetupToggle(this, "Is Auto Play", true, false);            Utils.SetupTwinButton(this, "Prev Image", () => {                prevImgAction.actionCallback();            }, "Next Image", () => {                nextImgAction.actionCallback();            }, false);            nextImgAction = Utils.SetupAction(this, "NextImageAction", () =>            {                SetNextImgPlayIndex();                SwitchImage();            });            prevImgAction = Utils.SetupAction(this, "PrevImageAction", () => {                SetPrevImgPlayIndex();                SwitchImage();            });            folderPath = Utils.SetupFolderChooser(this, "Set Folder", $"Custom/Assets/MyAssets", false, null);            folderPath.setCallbackFunction = (url) => {                currentFolderUrl = url;                                string dir = FileManagerSecure.GetDirectoryName(url);                List<string> files = new List<string>();                Utils.GetAllSubFiles(dir, ref files);                if (files.Count > 0)                {                    imageList.Clear();                    files.ForEach(p => {                        if (p.EndsWith(".jpg") || p.EndsWith(".png") || p.EndsWith(".jpeg") || p.EndsWith(".tiff"))                        {                            imageList.Add(p);                        }                    });                    if (imageList.Count <= 1)                    {                        SuperController.LogError("The folder needs to contain at least two valid pictures!");                        return;                    }                    Utils.LoadTexture(imageList[imgIndex + 1], slideTextureSetting, (tex) => {                        SetPictureRenderer(tex);                    });                    imgIndex = 1;                }            };            switchingInterval = Utils.SetupSliderFloat(this, "Switch Interval", 5f, 0.5f, 100, false);            translateDuration = Utils.SetupSliderFloat(this, "Transition Duration", 1.5f, 0.1f, 5f, false);                                    Utils.SetupSpacer(this, 30, true);            videoPlayerModule = new VideoPlayerModule(this);            videoPlayerModule.Init();            videoPlayerModule.onVideoTextureSettedCallback += (texture) => {                                                RenderObj.material.mainTexture = texture;            };                    }        private float timer;        private void Update()        {            videoPlayerModule.OnUpdate();                        if (isAutoPlay.val && imageList.Count > 1)            {                timer += Time.deltaTime;                if (timer > switchingInterval.val)                {                    timer = 0;                    SwitchImage();                }            }        }        int imgIndex = 0;        private void SwitchImage()        {            int nextImgIndex = imgIndex + 1;            if (nextImgIndex == imageList.Count) nextImgIndex = 0;            Utils.LoadTexture(imageList[nextImgIndex], slideTextureSetting, (tex) =>            {                SetPictureRenderer(tex);            });                        if (isAutoPlay.val)            {                switch (playModeChooser.val)                {                    case "Random":                        SetRandomImgPlayIndex();                        break;                    case "Sequence":                        SetNextImgPlayIndex();                        break;                    case "Sequence Inverse":                        SetPrevImgPlayIndex();                        break;                    default:                        break;                }            }        }        private void SetPictureRenderer(Texture2D tex)        {            RenderObj.material.mainTexture = tex;            Resources.UnloadUnusedAssets();        }        private void SetPrevImgPlayIndex()        {            imgIndex--;            if (imgIndex < 0) imgIndex = imageList.Count - 1;        }        private void SetNextImgPlayIndex()        {            imgIndex++;            if (imgIndex == imageList.Count) imgIndex = 0;        }        private void SetRandomImgPlayIndex()        {            if (randomPool.Count == 0)            {                for (int i = 0; i < imageList.Count; i++)                {                    randomPool.Add(i);                }            }            int tmpindex = Random.Range(0, randomPool.Count);            imgIndex = randomPool[tmpindex];            randomPool.RemoveAt(tmpindex);        }        private void OnDestroy()        {            Utils.OnDestroyUI();            videoPlayerModule.UnInit();        }    }}